## espresso 6.4.1

=== Makefile ===
# Copyright (C) 2001-2016 Quantum ESPRESSO group
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include make.inc

# execute a target irrespective of the presence of a file or directory 
# with the same name
.PHONY: install

default :
	@echo 'to install Quantum ESPRESSO, type at the shell prompt:'
	@echo '  ./configure [--prefix=]'
	@echo '  make [-j] target'
	@echo ' '
	@echo 'where target identifies one or multiple CORE PACKAGES:'
	@echo '  pw           basic code for scf, structure optimization, MD'
	@echo '  ph           phonon code, Gamma-only and third-order derivatives'
	@echo '  hp           calculation of the Hubbard parameters from DFPT'
	@echo '  pwcond       ballistic conductance'
	@echo '  neb          code for Nudged Elastic Band method'
	@echo '  pp           postprocessing programs'
	@echo '  pwall        same as "make pw ph pp pwcond neb"'
	@echo '  cp           CP code: Car-Parrinello molecular dynamics'
	@echo '  tddfpt       time dependent dft code'
	@echo '  gwl          GW with Lanczos chains'
	@echo '  ld1          utilities for pseudopotential generation'
	@echo '  upf          utilities for pseudopotential conversion'
	@echo '  xspectra     X-ray core-hole spectroscopy calculations'
	@echo '  couple       Library interface for coupling to external codes'
	@echo '  epw          Electron-Phonon Coupling with wannier functions'
	@echo '  gui          Graphical User Interface'
	@echo '  examples     fetch from web examples for all core packages'
	@echo '  test-suite   run semi-automated test-suite for regression testing'
	@echo '  all          same as "make pwall cp ld1 upf tddfpt hp"'
	@echo ' '
	@echo 'where target identifies one or multiple THIRD-PARTIES PACKAGES:'
	@echo '  gipaw        NMR and EPR spectra'
	@echo '  w90          Maximally localised Wannier Functions'
	@echo '  want         Quantum Transport with Wannier functions'
	@echo '  west         Many-body perturbation corrections Without Empty STates'
#	@echo '  SaX          Standard GW-BSE with plane waves'
	@echo '  yambo        electronic excitations with plane waves'
	@echo '  yambo-devel  yambo devel version'
	@echo '  SternheimerGW calculate GW using Sternheimer equations'
	@echo '  plumed       Metadynamics plugin for pw or cp'
	@echo '  d3q          general third-order code and thermal transport codes'
	@echo ' '
	@echo 'where target is one of the following suite operation:'
	@echo '  doc          build documentation'
	@echo '  links        create links to all executables in bin/'
	@echo '  tar          create a tarball of the source tree'
	@if test -d GUI/; then \
		echo '  tar-gui      create a standalone PWgui tarball from the GUI sources'; \
		echo '  tar-qe-modes create a tarball for QE-modes (Emacs major modes for Quantum ESPRESSO)'; fi
	@echo '  clean        remove executables and objects'
	@echo '  veryclean    remove files produced by "configure" as well'
	@echo '  distclean    revert distribution to the original status'

###########################################################
# Main targets
###########################################################

# The syntax "( cd PW ; $(MAKE) TLDEPS= all || exit 1)" below
# guarantees that error code 1 is returned in case of error and make stops
# If "|| exit 1" is not present, the error code from make in subdirectories
# is not returned and make goes on even if compilation has failed

pw : pwlibs
	if test -d PW ; then \
	( cd PW ; $(MAKE) TLDEPS= all || exit 1) ; fi

cp : bindir libs mods
	if test -d CPV ; then \
	( cd CPV ; $(MAKE) TLDEPS= all || exit 1) ; fi

ph : phlibs
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) TLDEPS= all || exit 1) ; fi

hp : hplibs
	if test -d HP; then \
	( cd HP; $(MAKE) TLDEPS= all || exit 1) ; fi

neb : pwlibs
	if test -d NEB; then \
	( cd NEB; $(MAKE) TLDEPS= all || exit 1) ; fi

tddfpt : phlibs
	if test -d TDDFPT; then \
	( cd TDDFPT; $(MAKE) TLDEPS= all || exit 1) ; fi

pp : pwlibs
	if test -d PP ; then \
	( cd PP ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

pwcond : pwlibs
	if test -d PWCOND ; then \
	( cd PWCOND ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

acfdt : phlibs
	if test -d ACFDT ; then \
	( cd ACFDT ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

# target still present for backward compatibility
gww:
	@echo '"make gww" is obsolete, use "make gwl" instead '

gwl : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gipaw : pwlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

d3q : phlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

ld1 : bindir libs mods
	if test -d atomic ; then \
	( cd atomic ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

upf : libs mods
	if test -d upftools ; then \
	( cd upftools ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

xspectra : pwlibs
	if test -d XSpectra ; then \
	( cd XSpectra ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

couple : pw cp
	if test -d COUPLE ; then \
	( cd COUPLE ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

epw: phlibs
	if test -d EPW ; then \
	( cd EPW ; $(MAKE) all || exit 1; \
		cd ../bin; ln -fs ../EPW/bin/epw.x . ); fi

travis : pwall epw
	if test -d test-suite ; then \
	( cd test-suite ; make run-travis || exit 1 ) ; fi

gui :
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= init; \
	    echo ; \
	    echo "  PWgui has been built in ./GUI/PWgui/. You may try it either as:  "; \
	    echo "         ./GUI/PWgui/pwgui" ; \
	    echo "     or"; \
	    echo "         cd ./GUI/PWgui";\
	    echo "         ./pwgui" ; \
	    echo ; \
	else \
	    echo ; \
	    echo "  Sorry, gui works only for git sources !!!" ; \
	    echo ; \
	fi

examples :
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

pwall : pw neb ph pp pwcond acfdt

all   : pwall cp ld1 upf tddfpt hp xspectra gwl 

###########################################################
# Auxiliary targets used by main targets:
# compile modules, libraries, directory for binaries, etc
###########################################################

pwlibs: bindir libs mods libks_solvers dftd3
	if test -d PW ; then \
	( cd PW ; $(MAKE) pw-lib || exit 1) ; fi

phlibs: pwlibs lrmods
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) ph-lib || exit 1) ; fi

hplibs: pwlibs lrmods
	if test -d HP; then \
	( cd HP; $(MAKE) hp-lib || exit 1) ; fi

gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) gwwa || exit 1 ) ; fi

pw4gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) pw4gwwa || exit 1 ) ; fi

mods : libiotk libfox libutil libla libfft
	( cd Modules ; $(MAKE) TLDEPS= all || exit 1 )

libks_solvers : libs libutil libla
	( cd KS_Solvers ; $(MAKE) TLDEPS= all || exit 1 )

libla : liblapack libutil libcuda
	( cd LAXlib ; $(MAKE) TLDEPS= all || exit 1 )

libfft : 
	( cd FFTXlib ; $(MAKE) TLDEPS= all || exit 1 )

libutil : 
	( cd UtilXlib ; $(MAKE) TLDEPS= all || exit 1 )

libs :
	( cd clib ; $(MAKE) TLDEPS= all || exit 1 )

lrmods : mods pwlibs
	( cd LR_Modules ; $(MAKE) TLDEPS= all || exit 1 )

dftd3 : mods
	( cd dft-d3 ; $(MAKE) TLDEPS= all || exit 1 )

bindir :
	test -d bin || mkdir bin

#############################################################
# Targets for external libraries
############################################################

libblas : 
	cd install ; $(MAKE) -f extlibs_makefile $@

liblapack: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libiotk: 
	cd install ; $(MAKE) -f extlibs_makefile $@
libfox: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libcuda: 
	cd install ; $(MAKE) -f extlibs_makefile $@
# In case of trouble with iotk and compilers, add
# FFLAGS="$(FFLAGS_NOOPT)" after $(MFLAGS)

#########################################################
# plugins
#########################################################

w90: bindir liblapack
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

want : 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

SaX : 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

yambo: 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

yambo-devel: 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

plumed: 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

west: pw
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

SternheimerGW: lrmods 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

#########################################################
# "make links" produces links to all executables in bin/
#########################################################

# Contains workaround for name conflicts (dos.x and bands.x) with WANT
links : bindir
	( cd bin/ ; \
	rm -f *.x ; \
	for exe in ../*/*/*.x ../*/bin/* ; do \
	    if test ! -L $$exe ; then ln -fs $$exe . ; fi \
	done ; \
	[ -f ../WANT/wannier/dos.x ] && \
		ln -fs ../WANT/wannier/dos.x ../bin/dos_want.x ; \
	[ -f ../PP/src/dos.x ] &&  \
		ln -fs ../PP/src/dos.x ../bin/dos.x ; \
	[ -f ../WANT/wannier/bands.x ] && \
		ln -fs ../WANT/wannier/bands.x ../bin/bands_want.x ; \
	[ -f ../PP/src/dos.x ] &&  ln -fs ../PP/src/bands.x ../bin/bands.x ; \
	[ -f ../W90/wannier90.x ] &&  ln -fs ../W90/wannier90.x ../bin/wannier90.x ;\
	)

#############################################################
# 'make install' works with "configure --prefix=PREFIX"
# - If the PREFIX/bin directory does not exists it creates it
#############################################################

install : 
	mkdir -p $(PREFIX)/bin ; \
	for x in `find * ! -path "test-suite/*" -name *.x -type f` ; do \
		cp -v $$x $(PREFIX)/bin/ ; done
	@echo -e '\nQuantum ESPRESSO binaries are installed in $(PREFIX)/bin\n'

#########################################################
# Run test-suite for numerical regression testing
# NB: it is assumed that reference outputs have been 
#     already computed once (usualy during release)
#########################################################

test-suite: pw cp 
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

#########################################################
# Other targets: clean up
#########################################################

# remove object files and executables
clean : 
	touch make.inc 
	for dir in \
		CPV LAXlib FFTXlib UtilXlib Modules PP PW EPW KS_Solvers \
		NEB ACFDT COUPLE GWW XSpectra PWCOND dft-d3 \
		atomic clib LR_Modules pwtools upftools \
		dev-tools extlibs Environ TDDFPT PHonon HP GWW Doc GUI \
	; do \
	    if test -d $$dir ; then \
		( cd $$dir ; \
		$(MAKE) TLDEPS= clean ) \
	    fi \
	done
	- @(cd install ; $(MAKE) -f plugins_makefile clean)
	- @(cd install ; $(MAKE) -f extlibs_makefile clean)
	- /bin/rm -rf bin/*.x tempdir

# remove files produced by "configure" as well
veryclean : clean
	- @(cd install ; $(MAKE) -f plugins_makefile veryclean)
	- @(cd install ; $(MAKE) -f extlibs_makefile veryclean)
	- rm -rf install/patch-plumed
	- cd install ; rm -f config.log configure.msg config.status
	- rm -rf include/configure.h install/make_wannier90.inc
	- cd install ; rm -fr autom4te.cache
	- cd install; ./clean.sh ; cd -
	- cd include; ./clean.sh ; cd -
	- rm -f espresso.tar.gz -
	- rm -rf make.inc -
	- rm -rf FoX
# remove everything not in the original distribution
distclean : veryclean
	- cd pseudo; ./clean_ps ; cd -
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

tar :
	@if test -f espresso.tar.gz ; then /bin/rm espresso.tar.gz ; fi
	# do not include unneeded stuff 
	find ./ -type f | grep -v -e /.svn/ -e'/\.' -e'\.o$$' -e'\.mod$$'\
		-e /.git/ -e'\.a$$' -e'\.d$$' -e'\.i$$' -e'_tmp\.f90$$' -e'\.x$$' \
		-e'~$$' -e'\./GUI' -e '\./tempdir' | xargs tar rvf espresso.tar
	gzip espresso.tar

#########################################################
# Tools for the developers
#########################################################
tar-gui :
	@if test -d GUI/PWgui ; then \

=== Doc/Makefile ===
LATEX   = pdflatex
LATEX2HTML = latex2html

PDFS = constraints_HOWTO.pdf  developer_man.pdf  user_guide.pdf plumed_quick_ref.pdf brillouin_zones.pdf
AUXS = $(PDFS:.pdf=.aux)
LOGS = $(PDFS:.pdf=.log)
OUTS = $(PDFS:.pdf=.out)
TOCS = $(PDFS:.pdf=.toc)

all:  pdf html
pdf:  $(PDFS)
html: user_guide developer_man

$(PDFS): %.pdf: %.tex
	$(LATEX)  $<
	$(LATEX)  $<

clean:
	- rm -f $(PDFS) $(AUXS) $(LOGS) $(OUTS) $(TOCS) *~
	- rm -rf user_guide/ developer_man/
	- rm -f INPUT_*.html INPUT_*.txt INPUT_*.xml qe-input-ref.html

developer_man: developer_man.pdf
	- rm -rf developer_man/
	- latex2html \
                -t "Developer's Manual for Quantum-ESPRESSO" \
                -html_version 3.2,math \
                -toc_depth 3 -split 3 -toc_stars -show_section_numbers \
                -local_icons -image_type png \
                developer_man.tex
	if test -d developer_man; then \
		cd developer_man; \
	        for file in *.html; do \
	 	        cp $$file /tmp/$$file; \
			cat /tmp/$$file | sed 's/HREF="http/NAME="http/g' | sed 's/mathend000#//g' - > $$file; \
			rm -f /tmp/$$file; \
	        done; \
	fi
	@if test -d developer_man; then \
		echo ""; \
		echo "***"; \
		echo "*** Developer's Manual created in developers_manual/developers_manual.html"; \
		echo "***"; \
		echo ""; \
	fi

user_guide: user_guide.pdf
	 - rm -rf user_guide/
	 - latex2html \
                -t "User's Guide for Quantum-ESPRESSO" \
                -html_version 3.2,math \
                -toc_depth 5 -split 5 -toc_stars -show_section_numbers \
                -local_icons -image_type png \
                user_guide.tex
	if test -d user_guide; then \
		cd user_guide; \
	        for file in *.html; do \
	                cp $$file /tmp/$$file; \
	                cat /tmp/$$file | sed 's/HREF="http/NAME="http/g' | sed 's/mathend000#//g' - > $$file; \
	                rm -f /tmp/$$file; \
	        done; \
	fi
	@if test -d user_guide; then \
		echo ""; \
		echo "***"; \
		echo "*** User's Guide created in user_guide/user_guide.html"; \
		echo "***"; \
		echo ""; \
	fi

brillouin_zones: brillouin_zones.pdf

=== EPW/Makefile ===

default: epw

all: epw

epw: 
	(cd src ; make all )
	- (mkdir -p bin)
	(cd bin ; ln -fs ../src/epw.x . )

clean:
	cd src ; rm -f *.o *.mod  *~ *.F90

distclean : clean
	rm -f src/epw.x bin/epw.x

release:
	cd ../ ; cp -r EPW EPW-release; cd EPW-release ; \
	rm -f src/*.o src/*.mod src/*.F90 src/*~ ; \
	rm bin/*.x ; \
	rm -rf examples/*/epw/out/* examples/*/epw/tmp/* \
	 examples/*/phonons/out/* examples/*/phonons/tmp/* \
	 examples/*/phonons/save/* ; \
	cd .. ; tar cfz EPW/EPW-release.tgz EPW-release ; \
	rm -rf EPW-release ; cd EPW

=== FFTXlib/Makefile ===
# Makefile for FFTXlib

include ../make.inc

FFTX = \
scatter_mod.o  \
fft_ggen.o  \
fft_fwinv.o  \
fft_scalar.o  \
fft_scalar.ARM_LIB.o  \
fft_scalar.DFTI.o  \
fft_scalar.ESSL.o  \
fft_scalar.FFTW.o  \
fftw_interfaces.o  \
fft_scalar.FFTW3.o  \
fft_scalar.SX6.o  \
fft_parallel.o  \
fft_interfaces.o  \
fft_interpolate.o \
stick_base.o  \
fft_smallbox.o  \
fft_smallbox_type.o  \
fft_support.o  \
fft_error.o  \
fft_stick.o  \
fft_types.o \
tg_gather.o \
fft_helper_subroutines.o \
fft_param.o


all : libqefft.a

libqefft.a: 	$(FFTX)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

fft_scalar.o : fft_scalar.f90  fft_scalar.FFTW3.f90  fft_scalar.FFTW.f90  fft_scalar.SX6.f90 fft_scalar.DFTI.f90  fft_scalar.ESSL.f90


fft_stick.o : fft_stick.c fftw.c fftw.h konst.h

TEST : test.o libqefft.a
	$(LD) $(LDFLAGS) -o fft_test.x test.o libqefft.a $(QELIBS)

TEST0:  test0.o libqefft.a
	$(LD) $(LDFLAGS) -o fft_test0.x test0.o libqefft.a $(QELIBS)

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L 

include make.depend

=== GWW/Makefile ===
include ../make.inc

all: libminpack pw4gwwa heada gwwa  bsea simplea simple_bsea simple_ipa

libminpack:
	( cd minpack ; $(MAKE) all || exit 1 )

pw4gwwa:
	( cd pw4gww ; $(MAKE) all || exit 1 )

heada: libminpack
	( cd head ; $(MAKE) all || exit 1 )

gwwa:
	( cd gww ; $(MAKE) all || exit 1 )

bsea: gwwa pw4gwwa
	( cd bse ; $(MAKE) all || exit 1 )

simplea: gwwa
	( cd simple ; $(MAKE) all || exit 1 )

simple_bsea: gwwa
	( cd simple_bse ; $(MAKE) all || exit 1 )

simple_ipa:
	( cd simple_ip ; $(MAKE) all || exit 1 )
clean: 
	( cd pw4gww  ; $(MAKE) clean )
	( cd head    ; $(MAKE) clean )
	( cd gww     ; $(MAKE) clean )
	( cd minpack ; $(MAKE) clean )
	( cd bse     ; $(MAKE) clean )
	( cd simple     ; $(MAKE) clean )
	( cd simple_bse     ; $(MAKE) clean )
	( cd simple_ip     ; $(MAKE) clean )

doc:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) all || exit 1 ) ; fi

doc_clean:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) clean ) ; fi

distclean: clean doc_clean

=== LAXlib/Makefile ===
# Makefile for LAXlib

include ../make.inc

MODFLAGS= $(MOD_FLAG)../UtilXlib $(MOD_FLAG)../ELPA/src  $(MOD_FLAG)../EIGENSOLVER_GPU/lib_eigsolve $(MOD_FLAG) .

LAX = la_types.o \
la_error.o \
cdiaghg.o \
rdiaghg.o \
dspev_drv.o \
ptoolkit.o \
transto.o \
distools.o \
zhpev_drv.o \
mp_diag.o \
set_mpi_comm_4_solvers.o \
export_gstart_2_solvers.o \
la_param.o


all : libqela.a


libqela.a:  $(LAX)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

la_test.x : test.o libqela.a 
	$(LD) $(LDFLAGS) -o la_test.x test.o libqela.a $(QELIBS)

TEST : la_test.x

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L *.x

include make.depend

=== LR_Modules/Makefile ===
# Makefile for LR_Modules

include ../make.inc

# location of needed modules and included files (if any)
MODFLAGS=$(BASEMOD_FLAGS) $(MOD_FLAG)$(TOPDIR)/PW/src

LR_MODULES = \
adddvscf.o \
addusdbec.o \
addusdbec_nc.o \
apply_dpot.o \
addusldos.o \
adddvepsi_us.o \
cft_wave.o \
cgsolve_all.o \
cg_psi.o \
ch_psi_all.o \
commutator_Hx_psi.o \
commutator_Vhubx_psi.o \
Coul_cut_2D_ph.o \
check_q_points_sym.o \
dfpt_tetra_mod.o \
dynmat_sub.o \
h_prec.o \
incdrhoscf.o \
incdrhoscf_nc.o \
dv_of_drho.o \
dgradcorr.o \
dnonloccorr.o \
dv_vdW_DF.o \
dv_rVV10.o \
newdq.o \
orthogonalize.o \
setup_offset_beta.o \
setup_nscf.o \
set_dbecsum_nc.o \
set_int3_nc.o \
smallgq.o \
lr_sm1_psi.o \
lr_addusddens.o \
localdos.o \
setup_dgc.o \
compute_vsgga.o \
setup_dmuxc.o \
setup_nbnd_occ.o \
setup_alpha_pv.o \
set_small_group_of_q.o \
sgam_lr.o \
star_q.o \
setqmod.o \
lr_orthoUwfc.o \
qdipol_cryst.o \
mode_group.o \
mix_pot.o \
lrcom.o

TLDEPS=mods pwlibs

all : liblrmod.a

liblrmod.a: $(LR_MODULES)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== Modules/Makefile ===
# Makefile for Modules

include ../make.inc

# location of needed modules
MODFLAGS=$(BASEMOD_FLAGS) \
         $(MOD_FLAG)../ELPA/src

# list of modules

MODULES = \
atom.o \
autopilot.o \
basic_algebra_routines.o \
becmod.o \
bfgs_module.o \
bspline.o \
bz_form.o \
cell_base.o  \
check_stop.o  \
command_line_options.o \
compute_dipole.o \
constants.o \
constraints_module.o \
control_flags.o \
coulomb_vcut.o \
dist.o \
electrons_base.o \
environment.o \
fcp_variables.o \
fd_gradient.o \
fft_base.o \
fft_rho.o \
fsockets.o \
funct.o \
generate_function.o \
gth.o \
gradutils.o \
gvecw.o \
input_parameters.o \
invmat.o \
io_files.o \
io_global.o  \
ions_base.o \
kernel_table.o \
kind.o \
libxc.o \
mdiis.o \
mm_dispersion.o \
mp_bands.o \
mp_exx.o \
mp_global.o \
mp_images.o \
mp_pools.o \
mp_wave.o \
mp_world.o \
noncol.o \
open_close_input_file.o \
parameters.o \
parser.o \
paw_variables.o \
plugin_flags.o \
plugin_arguments.o \
plugin_variables.o \
pseudo_types.o \
pw_dot.o \
qmmm.o \
radial_grids.o \
random_numbers.o \
read_cards.o \
read_input.o \
read_namelists.o \
read_ncpp.o \
read_pseudo.o \
read_upf_v1.o \
read_upf_v2.o \
read_upf_schema.o \
read_uspp.o \
recvec.o \
recvec_subs.o \
run_info.o \
space_group.o \
set_signal.o \
setqf.o \
splinelib.o \
timestep.o\
tsvdw.o\
emend_upf.o \
upf.o \
upf_to_internal.o \
uspp.o \
version.o \
wannier_gw.o\
wannier_new.o \
wave_base.o \
wavefunctions.o \
wrappers.o\
write_upf.o \
write_upf_v2.o \
write_upf_schema.o \
ws_base.o \
xc_vdW_DF.o \
xc_rVV10.o \
io_base.o \
qes_types_module.o \
qes_libs_module.o  \
qes_write_module.o \
qes_read_module.o \
qes_reset_module.o \
qes_init_module.o \
qes_read_module.o \
qes_bcast_module.o \
qexsd.o   \
qexsd_input.o \
hdf5_qe.o\
qeh5_module.o\
fox_init_module.o \
xsf.o \
wyckoff.o \
wypos.o \
zdotc_wrapper.o  \
zvscal.o 

# list of subroutines and functions (not modules) previously found in flib/

OBJS = \
atomic_number.o \
capital.o \
cryst_to_car.o \
erf.o \
expint.o \
functionals.o \
generate_k_along_lines.o \
lsda_functionals.o \
more_functionals.o \
has_xml.o \
inpfile.o \
int_to_char.o \
latgen.o \
linpack.o \
metagga.o \
matches.o \
plot_io.o \
radial_gradients.o \
rgen.o \
recips.o \
remove_tot_torque.o \
set_hubbard_l.o \
set_hubbard_n.o \
simpsn.o \
sort.o \
sph_bes.o \
sph_dbes.o \
trimcheck.o \
test_input_file.o \
date_and_tim.o \
volume.o \
dylmr2.o \
ylmr2.o \
wgauss.o \
w0gauss.o \
w1gauss.o \
deviatoric.o

TLDEPS=libiotk libfox libutil libla libfft

all : libqemod.a

## The following is needed only for lapack compiled from sources

dlamch.o : dlamch.f
	$(F77) $(FFLAGS_NOOPT) -c $<

libqemod.a: 	$(MODULES) $(OBJS)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi


clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== PHonon/Makefile ===
# Makefile for PH
sinclude ../make.inc

default: all

all: phonon phgamma_only finite_diffs

phonon:
	( cd PH ; $(MAKE) all || exit 1 )

ph-lib:
	( cd PH ; $(MAKE) libs-ph || exit 1 )

phgamma_only:
	( cd Gamma ; $(MAKE) all || exit 1 )

finite_diffs:
	( cd FD ; $(MAKE) all || exit 1 )

clean: phonon_clean phgamma_only_clean examples_clean finite_diffs_clean

phonon_clean:
	( cd PH ; $(MAKE) clean )

phgamma_only_clean:
	( cd Gamma ; $(MAKE) clean )

#third_order_q_clean:
#	( cd D3q ; $(MAKE) clean )

finite_diffs_clean:
	( cd FD ; $(MAKE) clean )

examples_clean:
	if test -d examples ; then \
	( cd examples ; ./clean_all ) ; fi

doc:
	if test -d Doc ; then \
	( cd Doc ; $(MAKE) all || exit 1 ) ; fi

doc_clean:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) clean ) ; fi

distclean: clean doc_clean

=== UtilXlib/Makefile ===
# Makefile for DAVID

include ../make.inc

# location of needed modules and included files (if any)
MODFLAGS=$(MOD_FLAG).

UTIL = clocks_handler.o \
cuda_util.o \
divide.o \
data_buffer.o \
error_handler.o \
find_free_unit.o \
fletcher32_mod.o \
mem_counter.o \
mp.o \
mp_base.o \
mp_base_gpu.o \
mp_bands_util.o \
parallel_include.o \
util_param.o \
thread_util.o

all : libutil.a


libutil.a:  $(UTIL)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L *.x

include make.depend

=== dev-tools/Makefile ===
TMP_FILES = INPUT_*.xml INPUT_*.xml.tcl *-help.tcl


pw: makedoc
	./check_gui pw

neb: makedoc
	./check_gui neb

ph: makedoc 
	./check_gui ph

pp: makedoc 
	./check_gui pp

projwfc: makedoc
	./check_gui projwfc

bands: makedoc
	./check_gui bands

dos: makedoc
	./check_gui dos

atomic: makedoc 
	./check_gui atomic

makedoc:
	(cd ..; $(MAKE) doc)

clean:
	- rm $(TMP_FILES)

=== test-suite/Makefile ===
#!/bin/bash
#
# Copyright (C) 2001 Quantum ESPRESSO
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include ./ENVIRONMENT

default :
	@echo 'To run Quantum ESPRESSO test-suite, type at the shell prompt:'
	@echo ' '
	@echo '  make target'
	@echo ' '
	@echo 'where <target> identifies an action'
	@echo ' run-tests                   : run-tests-serial (default)'
	@echo ' run-tests-serial            : run all tests in SERIAL' 
	@echo ' run-tests-XX-serial         : run tests for XX={pw,cp} only, as above' 
	@echo ' run-tests-parallel          : run all tests in PARALLEL (4 MPI)'
	@echo ' run-tests-XX-parallel       : run tests for XX={pw,cp} only, as above' 
	@echo ' run-custom-test testdir=DIR : run test in DIR only (serial)'
	@echo ' run-custom-test-parallel testdir=DIR : run test in DIR only (parallel 4 MPI)'
	@echo ' compare                     : compare last output with reference'
	@echo ' clean                       : clean stdout/sderr of all tests'
	@echo ' '
	@echo 'For additional advanced commands and settings please manually inspect'
	@echo 'ENVIRONMENT and Makefile files'

prolog :
	@sed "s|XXXXXX|$(ESPRESSO_ROOT)|g" < userconfig.tmp > userconfig

pseudo :
	@./check_pseudo.sh pw_
	@./check_pseudo.sh cp_
	@./check_pseudo.sh epw_

run-tests : run-tests-serial

run-tests-serial : run-tests-pw-serial run-tests-cp-serial 

run-tests-parallel : run-tests-pw-parallel run-tests-cp-parallel run-tests-ph-parallel run-tests-epw-parallel


run-tests-cp-serial : prolog pseudo
	@if ! test -d $(ESPRESSO_TMPDIR); then mkdir $(ESPRESSO_TMPDIR); fi 
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=cp_all

run-tests-cp-parallel : prolog pseudo
	@if ! test -d $(ESPRESSO_TMPDIR); then mkdir $(ESPRESSO_TMPDIR); fi 
	env QE_USE_MPI=1 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=cp_all

run-tests-pw-serial : prolog pseudo
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pw_all

run-tests-pw-parallel : prolog pseudo
	env QE_USE_MPI=1 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pw_all

run-tests-ph-serial : prolog pseudo
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=ph_all

run-tests-ph-parallel : prolog pseudo
	env QE_USE_MPI=1 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=ph_all

run-tests-epw-serial : prolog pseudo
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_partial

run-tests-epw-parallel : prolog pseudo
	env QE_USE_MPI=1 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_all

run-travis : clean prolog pseudo
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_base

run-custom-test : run-custom-test-serial

run-custom-test-serial : prolog pseudo
	@if test -d $(testdir); then \
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=$(testdir) ; fi

run-custom-test-parallel : prolog pseudo
	@if test -d $(testdir); then \
	env QE_USE_MPI=1 ${TESTCODE_DIR}/bin/testcode.py --verbose --category=$(testdir) ; fi


run-tests-xsd-pw-serial : prolog pseudo
	cd xsd_pw ; for file in ./*.in ; do \
  	echo "Running using $$file" ; \
		env QE_USE_MPI=0 ../run-pw.sh -in $$file &> $$file.out ; \
		python ../validate_xsd_pw.py $$file; \
    done ; cd ..

create-reference-cp : pseudo prolog
	@if ! test -d $(ESPRESSO_TMPDIR); then mkdir $(ESPRESSO_TMPDIR); fi 
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --category=cp_all make-benchmarks

create-reference-pw : pseudo prolog
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --category=pw_all make-benchmarks

create-reference-epw : pseudo prolog
	env QE_USE_MPI=0 ${TESTCODE_DIR}/bin/testcode.py --category=epw_all make-benchmarks


compare : compare-cp compare-pw compare-ph compare-epw

compare-cp : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=cp_all  --verbose compare 2>&1 | tee out.CP.`date +%Y%m%d_%H%M%S`

compare-pw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=pw_all  --verbose compare 2>&1 | tee out.PW.`date +%Y%m%d_%H%M%S`

compare-ph : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=ph_all  --verbose compare 2>&1 | tee out.PH.`date +%Y%m%d_%H%M%S`

compare-epw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=epw_all  --verbose compare 2>&1 | tee out.EPW.`date +%Y%m%d_%H%M%S`

clean:
# output files
	@for x in `find pw_* -name "test*"`; do rm -rf $$x; done
	@for x in `find ph_* -name "test*"`; do rm -rf $$x; done
	@for x in `find cp_* -name "test*"`; do rm -rf $$x; done
	@for x in `find epw_* -name "test*"`; do rm -rf $$x; done
# error files
	@for x in `find pw_* -name "CRASH"`; do rm -rf $$x; done
	@for x in `find ph_* -name "CRASH*"`; do rm -rf $$x; done
	@for x in `find cp_* -name "CRASH"`; do rm -rf $$x; done
	@for x in `find epw_* -name "CRASH"`; do rm -rf $$x; done
# pwscf data files
	@rm -rf pw_*/pwscf.* ph_*/pwscf.* epw_*/pwscf.*
# cp data files
	@rm -rf cp_si/si_*.* co_o2/o2_*.* cp_h2o/h2o_*.* cp_sio2/sio2_*.*
# Special case for 'pw_vc-relax' test-case
	@rm -f pw_vc-relax/ave pw_vc-relax/e pw_vc-relax/tv pw_vc-relax/p pw_vc-relax/eal pw_vc-relax/avec
# Special case for 'noexe_langevin' test-case
	@rm -f noexe_langevin/trajectory-pwscf.xyz
# Special case for PH
	@for x in `find ph_* -name "*dyn"`; do rm -rf $$x; done
# Cleaning PH final files
	@rm -rf ph_*/_ph0 ph_*/*.save ph_*/*.xml ph_*/a2F.* ph_*/*.dyn? ph_*/alpha2F.dat \
		ph_*/dyna2F ph_*/elph.gamma* ph_*/gam.lines ph_*/lambda ph_*/lambda.dat \
		ph_*/elph_dir ph_*/Al444.* ph_*/matdyn.modes ph_*/phonon.dos
# Cleaning EPW final files
	@rm -rf epw_*/_ph0 epw_*/*.save epw_*/*.wfc* epw_*/*.dyn* \
		epw_*/*.qdos_25.00 epw_*/*.P epw_*/*.freq epw_*/*.wout \
		epw_*/*.fmt epw_*/*.epmat_wanep epw_*/*.kgmap epw_*/*.egnv epw_*/*.ikmap \
		epw_*/*.nnkp epw_*/*.imag_iso_25.00 epw_*/*.pade_iso_25.00 epw_*/*.epmatwp* \
		epw_*/*.acon_iso_25.00 epw_*/*.crystal.fmt epw_*/*.a2f_iso epw_*/*.ephmat* \
		epw_*/*.kmap epw_*/*.lambda_k_pairs epw_*/*.ukk epw_*/*.imag_aniso_25.00 \
		epw_*/*.pade_aniso_gap0_25.00 epw_*/*.win epw_*/*.imag_aniso_gap0_25.00 \
		epw_*/*.chk epw_*/*.phdos_proj epw_*/*..a2f epw_*/*.imag_aniso_gap_FS_25.00 \
		epw_*/*.epmatwp epw_*/*.phdos epw_*/*.epwane epw_*/*.ephmat \
		epw_*/*.fmt epw_*/*.H epw_*/*.epb* epw_*/*self epw_*/*.a2f epw_*/*.01 \
		epw_*/*.kpt epw_*/*.gnu epw_*/*.eig epw_*/*.lambda_FS epw_*/*.sigma_restart* \
		epw_*/specfun.phon epw_*/specfun_sup.phon epw_*/*.tau_restart* \
                epw_*/*_elcond_* epw_*/fort.* epw_*/decay.* epw_*/scattering_rate* \
                epw_*/*.fc.* epw_*/*_band.dat epw_*/*F_restart* epw_*/*F_restart_CB* \
                epw_*/*.mmn epw_*/*.epmatkq* epw_*/*.epmatkqcb* epw_*/sparse* \
                epw_*/*.Fin_restart* epw_*/*.Fin_restartcb* epw_*/*.acon_iso_* \
                epw_*/*.imag_aniso* epw_*/*.imag_iso* epw_*/*.pade_* epw_*/*qdos_* \
                epw_*/epsilon2_indabs.dat epw_*/epsilon2_indabs_lorenz.dat \
                epw_mob_ibte_sym/save epw_*/*.bvec epw_*/*.fc epw_*/*.xml epw_*/*.labelinfo.dat \
                epw_mob_ibte/save epw_mob/save
                
# Special cases for EPW
	@rm -rf epw_base/save epw_super/save

# Special case EPW
	@rm -rf epw_trev/save	
	@rm -rf epw_trev_uspp/save	
	@rm -f userconfig

# Calling 'purge' means remove all reference outputs... be careful!
purge: clean
	@for x in `find pw_* -name "benchmark*"`; do rm -rf $$x; done
	@for x in `find cp_* -name "benchmark*"`; do rm -rf $$x; done

=== debian/changelog ===
espresso (6.4.1-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:39:39 +0100

espresso (6.4.1-1build1) focal; urgency=medium

  * No-change rebuild against libscalapack-openmpi2.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 04 Jan 2020 20:12:12 +0000

espresso (6.4.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/pseudopotential_dir.patch: Refreshed. 
  * debian/patches/install_bindir.patch: Updated.
  * debian/patches/configure_fix_ppc64_define.patch: Refreshed.
  * debian/patches/make-install-PHONY.patch: Likewise.
  * debian/patches/disable_pseudo_download.patch: Updated.

 -- Michael Banck <mbanck@debian.org>  Sat, 20 Jul 2019 09:41:45 -0300

=== debian/control ===
Source: espresso
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 11),
               gfortran,
               latex2html,
               libblas-dev,
               libelpa-dev (>= 2016.05.001),
               libfftw3-dev,
               liblapack-dev,
               libscalapack-mpi-dev,
               mpi-default-dev,
               netpbm,
               tcl,
               tcllib,
               xsltproc
Standards-Version: 4.2.0
Homepage: http://www.quantum-espresso.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/espresso
Vcs-Git: https://salsa.debian.org/debichem-team/espresso.git

Package: quantum-espresso
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: quantum-espresso-data
Description: Electronic-Structure and Ab-Initio Molecular Dynamics Suite
 Quantum ESPRESSO (formerly known as PWscf) is an integrated suite of computer
 codes for electronic-structure calculations and materials modeling at the
 nanoscale. It is based on density-functional theory, plane waves, and
 pseudopotentials (both norm-conserving, ultrasoft, and PAW).
 .
 Features include:
  * Ground-state single-point and band structure calculations using plane-wave
    self-consistent total energies, forces and stresses
  * Separable norm-conserving and ultrasoft (Vanderbilt) pseudo-potentials, PAW
    (Projector Augmented Waves)
  * Various exchange-correlation functionals, from LDA to generalized-gradient
    corrections (PW91, PBE, B88-P86, BLYP) to meta-GGA, exact exchange (HF) and
    hybrid functionals (PBE0, B3LYP, HSE)
  * Car-Parrinello and Born-Oppenheimer Molecular Dynamics
  * Structural Optimization including transition states and minimum energy
    paths
  * Spin-orbit coupling and noncollinear magnetism
  * Response properties including phonon frequencies and
    eigenvectors, effective charges and dielectric tensors, Infrared and
    Raman cross-sections, EPR and NMR chemical shifts
  * Spectroscopic properties like K- and L1-edge X-ray Absorption Spectra (XAS)
    and electronic excitations

Package: quantum-espresso-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: quantum-espresso (<< 6.3-1)
Replaces: quantum-espresso (<< 6.3-1)
Description: Electronic-Structure and Ab-Initio Molecular Dynamics Suite (Documentation)
 Quantum ESPRESSO is an integrated suite of computer codes for
 electronic-structure calculations and materials modeling at the nanoscale. It
 is based on density-functional theory, plane waves, and pseudopotentials (both
 norm-conserving, ultrasoft, and PAW).
 .
 This package contains a limited set of pseudo-potentials and example files.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?-(\d[\d.]*)\.tar\.gz%espresso-$1.tar.gz%" \
 https://gitlab.com/QEF/q-e/tags (?:.*?/)?q-e-qe-(\d[\d.]*)\.tar\.gz
